function NextUpFunctions.DruidFeralPriority(SingleTargetPriority)
	local PriorityIcon
	local InterruptIcon
	local ReminderIcon
	local ResourceLow
	local CurrentTime = GetTime()
	local GCD = 1
	
	-- Get cooldowns
	local NaturesSwiftnessCD = NextUpFunctions.GetSpellCooldown(132158)
	local FaerieSwarmCD = NextUpFunctions.GetSpellCooldown(102355)
	local SkullBashCD = NextUpFunctions.GetSpellCooldown(106839)
	local TigersFuryCD = NextUpFunctions.GetSpellCooldown(5217)
	local FaerieFireCD = NextUpFunctions.GetSpellCooldown(770)
	local BerserkCD = NextUpFunctions.GetSpellCooldown(106952)

	-- Get buffs
	local PredatorySwiftnessUp = UnitBuff("player", GetSpellInfo(16974))
	local ClearcastingUp = UnitBuff("player", GetSpellInfo(16870))
	local TigersFuryUp = UnitBuff("player", GetSpellInfo(5217))

	local SavageRoarUp,_,_,_,_,_,SavageRoarExpirationTime = UnitBuff("player", GetSpellInfo(127538))
	local SavageRoarRemaining = 0
	if SavageRoarUp then SavageRoarRemaining = (SavageRoarExpirationTime - CurrentTime) end

	local BerserkUp,_,_,_,_,_,BerserkExpirationTime = UnitBuff("player", GetSpellInfo(106952))
	local BerserkRemaining = 0
	if BerserkUp then BerserkRemaining = (BerserkExpirationTime - CurrentTime) end
	
	local _,_,_,DreamOfCenariusCharges = UnitBuff("player", GetSpellInfo(108373))
	if not DreamOfCenariusCharges then DreamOfCenariusCharges = 0 end
	
	local RipUp
	local RipRemaining = 0
	local _,_,_,_,_,_,RipExpirationTime,RipCaster = UnitDebuff("target", GetSpellInfo(1079))
	if (RipCaster == "player") then
		RipUp = true
		RipRemaining = (RipExpirationTime - CurrentTime)
	end
	
	local RakeUp
	local RakeRemaining = 0
	local _,_,_,_,_,_,RakeExpirationTime,RakeCaster = UnitDebuff("target", GetSpellInfo(1822))
	if (RakeCaster == "player") then
		RakeUp = true
		RakeRemaining = (RakeExpirationTime - CurrentTime)
	end
	
	local ThrashUp
	local ThrashRemaining = 0
	local _,_,_,_,_,_,ThrashExpirationTime,ThrashCaster = UnitDebuff("target", GetSpellInfo(106830))
	if (ThrashCaster == "player") then
		ThrashUp = true
		ThrashRemaining = (ThrashExpirationTime - CurrentTime)
	end

	local WeakenedArmorUp 
	if (UnitDebuff("target", GetSpellInfo(113746))) then
		WeakenedArmorUp = true
	end
	
	-- Get power levels
	local Energy = UnitPower("player", 3)
	local ComboPoints = GetComboPoints("player", "target")
	
	-- Get target's health and spells being cast
	local TargetHP = UnitHealth("target")
	local TargetHPMax = UnitHealthMax("target")
	local TargetHPPercent = TargetHP / TargetHPMax * 100

------------------
-- PriorityIcon --
------------------

	if NextUpFunctions.TargetIsEnemy() then

		if SingleTargetPriority then
		
			-- Single target priority --

			-- Healing touch if Predatory Swiftness has procced and Dream of Cenarius is down
			if(GetSpellInfo(GetSpellInfo(5185)) and PredatorySwiftnessUp and (DreamOfCenariusCharges == 0)) then
				_,_,PriorityIcon = GetSpellInfo(5185)

			-- Savage Roar if it's down
			elseif(GetSpellInfo(GetSpellInfo(52610)) and (ComboPoints > 0) and not SavageRoarUp) then
				_,_,PriorityIcon = GetSpellInfo(52610)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end

			-- Keep Faerie Fire up...
			elseif(GetSpellInfo(GetSpellInfo(770)) and not WeakenedArmorUp and (FaerieFireCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(770)

			-- ...or Faerie Swarm if the player has the talent
			elseif(GetSpellInfo(GetSpellInfo(102355)) and not WeakenedArmorUp and (FaerieSwarmCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(102355)
			
			-- Healing touch if Predatory Swiftness has procced and player has at least 4 combo points and Dream of Cenarius has less than 2 stacks
			elseif(GetSpellInfo(GetSpellInfo(5185)) and PredatorySwiftnessUp and (ComboPoints >= 4) and (DreamOfCenariusCharges < 2)) then
				_,_,PriorityIcon = GetSpellInfo(5185)

			-- Healing touch if Natures Swiftnessis up
			elseif(GetSpellInfo(GetSpellInfo(5185)) and NaturesSwiftnessUp) then
				_,_,PriorityIcon = GetSpellInfo(5185)

			-- Use Tiger's Fury if Omen of Clarity isn't up and energy is below 35 (to avoid capping)
			elseif(GetSpellInfo(GetSpellInfo(5217)) and (Energy <= 35) and (TigersFuryCD == 0) and not ClearcastingUp) then
				_,_,PriorityIcon = GetSpellInfo(5217)

			-- Berserk if Tigers Fury is up
			elseif(GetSpellInfo(GetSpellInfo(106952)) and TigersFuryUp and (BerserkCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(106952)

			-- Ferocious Bite to refresh Rip if it's just about to wear off, no matter how many combo points
			elseif(GetSpellInfo(GetSpellInfo(22568)) and RipUp and (RipRemaining < 3) and (ComboPoints > 0) and (TargetHPPercent <= 25)) then
				_,_,PriorityIcon = GetSpellInfo(22568)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end

			-- Thrash if it is about to expire and Omen of Clarity is up
			elseif(GetSpellInfo(GetSpellInfo(106832)) and (ThrashRemaining < 3) and ClearcastingUp) then
				_,_,PriorityIcon = GetSpellInfo(106832)
				if (Energy < 50 and not ClearcastingUp) then ResourceLow = true end
				
			-- Savage Roar if it's just about to wear off and target health is below 25%, no matter how many combo points
			elseif(GetSpellInfo(GetSpellInfo(52610)) and (SavageRoarRemaining < 2) and (ComboPoints > 0) and (TargetHPPercent <= 25)) then
				_,_,PriorityIcon = GetSpellInfo(52610)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end

			-- Nature's Swiftness if Dream of Cenarius is down, Predatory Swiftness is down, Combo Points are capped and Target health is below 25%
			elseif(GetSpellInfo(GetSpellInfo(132158)) and (DreamOfCenariusCharges == 0) and not PredatorySwiftnessUp and (ComboPoints >= 5) and (TargetHPPercent <= 25) and (NaturesSwiftnessCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(132158)

			-- Pool Energy if capped on Combo Points, Rip is up, Target health is below 25% and Berserk...
			elseif((DreamOfCenariusCharges == 0) and not PredatorySwiftnessUp and (ComboPoints >= 5) and (TargetHPPercent <= 25) and ((not BerserkUp and (Energy < 50)) or ((BerserkRemaining > 1) and (Energy < 25)))) then
				_,_,PriorityIcon = false

			-- Ferocious Bite to refresh Rip at 5 Combo Points
			elseif(GetSpellInfo(GetSpellInfo(22568)) and RipUp and (ComboPoints >= 5) and (TargetHPPercent <= 25)) then
				_,_,PriorityIcon = GetSpellInfo(22568)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end

			-- Rip at 5 Combo Points if Dream of Cenarius is up and rip is about to expire
			elseif(GetSpellInfo(GetSpellInfo(1079)) and (ComboPoints >= 5) and (DreamOfCenariusCharges > 0) and (RipRemaining < 2)) then
				_,_,PriorityIcon = GetSpellInfo(1079)
				if (Energy < 30 and not ClearcastingUp) then ResourceLow = true end

			-- Rip at 5 Combo Points if it's about to expire and Berserk is up or Tiger's fury...
			elseif(GetSpellInfo(GetSpellInfo(1079)) and (ComboPoints >= 5) and (RipRemaining < 2) and (BerserkUp or (RipRemaining + 1.9 <= TigersFuryCD))) then
				_,_,PriorityIcon = GetSpellInfo(1079)
				if (Energy < 30 and not ClearcastingUp) then ResourceLow = true end

			-- Savage Roar if it's just about to wear off and Rip will not last 2 more seconds than Savage Roar...
			elseif(GetSpellInfo(GetSpellInfo(52610)) and (SavageRoarRemaining <= 3) and (ComboPoints > 0) and (SavageRoarRemaining + 2 > RipRemaining)) then
				_,_,PriorityIcon = GetSpellInfo(52610)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end
				
			-- ...or Savage Roar at 5 Combo Points even if it isn't close to expiring, if Rip will last that long
			elseif(GetSpellInfo(GetSpellInfo(52610)) and (SavageRoarRemaining <= 6) and (ComboPoints >= 5) and (SavageRoarRemaining + 2 < RipRemaining)) then
				_,_,PriorityIcon = GetSpellInfo(52610)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end
				
			-- Ferocious Bite to refresh Rip at 5 Combo Points if Rip has more than 6 seconds left
			elseif(GetSpellInfo(GetSpellInfo(22568)) and (ComboPoints >= 5) and (RipRemaining > 6) and (TargetHPPercent <= 25)) then
				_,_,PriorityIcon = GetSpellInfo(22568)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end

			-- Rake if Dream of Cenarius is up or if it is about to expire
			elseif(GetSpellInfo(GetSpellInfo(1822)) and ((DreamOfCenariusCharges > 0) and (RakeRemaining < 9)) or (RakeRemaining < 3)) then
				_,_,PriorityIcon = GetSpellInfo(1822)
				if (Energy < 35 and not ClearcastingUp) then ResourceLow = true end

			-- Thrash if it is about to expire and Rip has more than 4 seconds left or Berserk is up
			elseif(GetSpellInfo(GetSpellInfo(106832)) and (ThrashRemaining < 3) and ((RipRemaining >= 4) or BerserkUp)) then
				_,_,PriorityIcon = GetSpellInfo(106832)
				if (Energy < 50 and not ClearcastingUp) then ResourceLow = true end

			-- Thrash if it is about to expire and Combo Points are capped
			elseif(GetSpellInfo(GetSpellInfo(106832)) and (ThrashRemaining < 3) and (ComboPoints >= 5)) then
				_,_,PriorityIcon = GetSpellInfo(106832)
				if (Energy < 50 and not ClearcastingUp) then ResourceLow = true end

			-- Shred if Omen of Clarity or Berserk is up
			elseif(GetSpellInfo(GetSpellInfo(5221)) and (ClearcastingUp or BerserkUp)) then
				_,_,PriorityIcon = GetSpellInfo(5221)
				if (Energy < 40 and not ClearcastingUp) then ResourceLow = true end

			-- Mangle
			elseif(GetSpellInfo(GetSpellInfo(33876))) then
				_,_,PriorityIcon = GetSpellInfo(33876)
				if (Energy < 35 and not ClearcastingUp) then ResourceLow = true end
				
			end

		else

			-- AoE priority --

			-- Savage Roar if it's just about to wear off, no matter how many combo points
			if(GetSpellInfo(GetSpellInfo(52610)) and (ComboPoints > 0) and (SavageRoarRemaining < 2)) then
				_,_,PriorityIcon = GetSpellInfo(52610)
				if (Energy < 25 and not ClearcastingUp) then ResourceLow = true end

			-- 5 Combo point Rip 
			elseif(GetSpellInfo(GetSpellInfo(1079)) and (ComboPoints == 5)) then
				_,_,PriorityIcon = GetSpellInfo(1079)
				if (Energy < 30 and not ClearcastingUp) then ResourceLow = true end

			-- Keep Thrash up
			elseif(GetSpellInfo("Thrash") and not ThrashUp) then
				_,_,PriorityIcon = GetSpellInfo(106830)
				if (Energy < 50 and not ClearcastingUp) then ResourceLow = true end

			-- Swipe on CD
			elseif(GetSpellInfo(GetSpellInfo(62078))) then
				_,_,PriorityIcon = GetSpellInfo(62078)
				if (Energy < 45 and not ClearcastingUp) then ResourceLow = true end

			-- Keep Faerie Fire up...
			elseif(GetSpellInfo(GetSpellInfo(770)) and not WeakenedArmorUp and (FaerieFireCD == 0)) then
				_,_,PriorityIcon = GetSpellInfo(770)

			-- ...or Faerie Swarm if the player has the talent
			elseif(GetSpellInfo(GetSpellInfo(102355)) and not WeakenedArmorUp and (FaerieSwarmCD == 0)) then
				_,_,PriorityIcon = GetSpellInfo(102355)

			end


		end
		
-------------------
-- InterruptIcon --
-------------------

		-- Skull Bash if target is casting an interruptable spell
		if (GetSpellInfo(GetSpellInfo(106839)) and UnitIsEnemy("target", "player") and (SkullBashCD == 0) and NextUpFunctions.TargetSpellcastIsInterruptable()) then
			_,_,InterruptIcon = GetSpellInfo(106839)

		end
		
	end
	
------------------
-- ReminderIcon --
------------------

	-- Mark of the Wild
	if(GetSpellInfo(GetSpellInfo(1126)) and not NextUpFunctions.StatBuffUp()) then
		_,_,ReminderIcon = GetSpellInfo(1126)

	end

	return PriorityIcon, InterruptIcon, ReminderIcon, ComboPoints, ResourceLow
	
end