function NextUpFunctions.PaladinProtectionPriority(SingleTargetPriority)
	local PriorityIcon
	local InterruptIcon
	local ReminderIcon
	local GCD = NextUpFunctions.GetGCD(105361) -- Get Seal of Command CD
	
	-- Get cooldowns
	local ShieldOfTheRighteousCD = NextUpFunctions.GetSpellCooldown(53600)
	local CrusaderStrikeCD = NextUpFunctions.GetSpellCooldown(35395)
	local AvengersShieldCD = NextUpFunctions.GetSpellCooldown(31935)
	local HammerOfWrathCD = NextUpFunctions.GetSpellCooldown(24275)
	local ConsecrationCD = NextUpFunctions.GetSpellCooldown(26573)
	local HolyWrathCD = NextUpFunctions.GetSpellCooldown(119072)
	local JudgmentCD = NextUpFunctions.GetSpellCooldown(20271)
	local ExorcismCD = NextUpFunctions.GetSpellCooldown(879)
	local RebukeCD = NextUpFunctions.GetSpellCooldown(96231)

	-- Get buffs
	local _,_,_,_,_,_,_,BlessingOfKingsSource = UnitBuff("player", GetSpellInfo(20217))
	local _,_,_,_,_,_,_,BlessingOfMightSource = UnitBuff("player", GetSpellInfo(19740))

	local RighteousFuryUp = UnitBuff("player", GetSpellInfo(25780))
	local DivinePurposeUp = UnitBuff("player", GetSpellInfo(86172))
	local AvengingWrathUp = UnitBuff("player", GetSpellInfo(31884))
	local GrandCrusaderUp = UnitBuff("player", GetSpellInfo(85043))
	local SacredShieldUp = UnitBuff("player", GetSpellInfo(20925))
	local WeakenedBlowsUp = UnitDebuff("target", GetSpellInfo(115798))
	local ShieldOfTheRighteousUp = UnitDebuff("target", GetSpellInfo(53600))

	-- Get power levels
	local HolyPower = UnitPower("player", 9)
	local ThreeHolyPower = false
	if ((HolyPower >= 3) or (DivinePurposeUp)) then ThreeHolyPower = true end

	-- Get target's health and spells being cast
	local TargetHP = UnitHealth("target")
	local TargetHPMax = UnitHealthMax("target")
	local TargetHPPercent = TargetHP / TargetHPMax * 100

------------------
-- PriorityIcon --
------------------

	if NextUpFunctions.TargetIsEnemy() then

		if SingleTargetPriority then
		
			-- Single target priority --
		
			-- Hammer of the Righteous if no Weakened Blows debuff
			if(GetSpellInfo(GetSpellInfo(53595)) and (CrusaderStrikeCD <= GCD) and not WeakenedBlowsUp) then
				_,_,PriorityIcon = GetSpellInfo(53595)
			
			-- Crusader Strike
			elseif(GetSpellInfo(GetSpellInfo(35395)) and CrusaderStrikeCD <= GCD) then
				_,_,PriorityIcon = GetSpellInfo(35395)

			-- Keep Sacred Shield up
			elseif (GetSpellInfo(GetSpellInfo(20925)) and not SacredShieldUp) then
				_,_,PriorityIcon = GetSpellInfo(20925)
			
			-- Judgment
			elseif(GetSpellInfo(GetSpellInfo(20271)) and JudgmentCD <= GCD) then
				_,_,PriorityIcon = GetSpellInfo(20271)

			-- Avenger's Shield
			elseif(GetSpellInfo(GetSpellInfo(31935)) and AvengersShieldCD <= GCD) then
				_,_,PriorityIcon = GetSpellInfo(31935)

			-- Hammer of Wrath
			elseif(GetSpellInfo(GetSpellInfo(24275)) and HammerOfWrathCD <= GCD and TargetHPPercent <= 20) then
				_,_,PriorityIcon = GetSpellInfo(24275)

			-- Consecration
			elseif(GetSpellInfo(GetSpellInfo(26573)) and ConsecrationCD <= GCD) then
				_,_,PriorityIcon = GetSpellInfo(26573)

			-- Holy Wrath
			elseif(GetSpellInfo(GetSpellInfo(119072)) and HolyWrathCD <= GCD) then
			_,_,PriorityIcon = GetSpellInfo(119072)

			end

		else

			-- AoE priority --

			-- Hammer of the Righteous
			if(GetSpellInfo(GetSpellInfo(53595)) and (CrusaderStrikeCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(53595)
			
			-- Keep Sacred Shield up
			elseif (GetSpellInfo(GetSpellInfo(20925)) and not SacredShieldUp) then
				_,_,PriorityIcon = GetSpellInfo(20925)
			
			-- Judgment
			elseif(GetSpellInfo(GetSpellInfo(20271)) and (JudgmentCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(20271)

			-- Avenger's Shield if Grand Crusader buff
			elseif(GetSpellInfo(GetSpellInfo(31935)) and GrandCrusaderUp and (AvengersShieldCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(31935)

			-- Consecration
			elseif(GetSpellInfo(GetSpellInfo(26573)) and (ConsecrationCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(26573)

			-- Avenger's Shield if Grand Crusader buff
			elseif(GetSpellInfo(GetSpellInfo(31935)) and (AvengersShieldCD <= GCD)) then
				_,_,PriorityIcon = GetSpellInfo(31935)

			-- Holy Wrath
			elseif(GetSpellInfo(GetSpellInfo(119072)) and (HolyWrathCD <= GCD) and ManaPercent >= 20) then
			_,_,PriorityIcon = GetSpellInfo(119072)

			end
		end
		
-------------------
-- InterruptIcon --
-------------------

		-- Shield of the Righteous
		if (GetSpellInfo(GetSpellInfo(53600)) and ThreeHolyPower and (ShieldOfTheRighteousCD == 0) and not ShieldOfTheRighteousUp) then
			_,_,InterruptIcon = GetSpellInfo(53600)
		
		-- Rebuke
		elseif (GetSpellInfo(GetSpellInfo(96231)) and (RebukeCD == 0) and NextUpFunctions.TargetSpellcastIsInterruptable()) then
			_,_,InterruptIcon = GetSpellInfo(96231)

		end
	end
	
------------------
-- ReminderIcon --
------------------

 	-- Make sure Righteous Fury is on
	if(not RighteousFuryUp) then
		_,_,ReminderIcon = GetSpellInfo(25780)

	-- Blessing of Kings
	elseif(GetSpellInfo(GetSpellInfo(20217)) and not NextUpFunctions.StatBuffUp() and not (BlessingOfMightSource == "player")) then
		_,_,ReminderIcon = GetSpellInfo(20217)

	-- Blessing of Might
	elseif(GetSpellInfo(GetSpellInfo(19740)) and not NextUpFunctions.MasteryBuffUp() and not (BlessingOfKingsSource == "player")) then
		_,_,ReminderIcon = GetSpellInfo(19740)
		
	end

	return PriorityIcon, InterruptIcon, ReminderIcon, HolyPower
end